/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.geometries.viewer3d.controls.clip_editor;

import org.jogamp.java3d.ModelClip;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class ClipPlanesUI extends javax.swing.JPanel
{

    protected ModelClip modelClip;

    /**
     * Set the value of modelClip
     *
     * @param modelClip new value of modelClip
     */
    public void setModelClip(ModelClip modelClip)
    {
        this.modelClip = modelClip;
        clipPlaneUI1.setData(modelClip, 0);
        clipPlaneUI2.setData(modelClip, 1);
        clipPlaneUI3.setData(modelClip, 2);
    }

    /**
     * Creates new form ClipPlanesUI
     */
    public ClipPlanesUI()
    {
        initComponents();
    }

    public void setExtents(float[][] extents)
    {
        clipPlaneUI1.setExtents(extents[0][0], extents[1][0]);
        clipPlaneUI2.setExtents(extents[0][1], extents[1][1]);
        clipPlaneUI3.setExtents(extents[0][2], extents[1][2]);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        clipPlaneUI1 = new org.visnow.vn.geometries.viewer3d.controls.clip_editor.ClipPlaneUI();
        clipPlaneUI2 = new org.visnow.vn.geometries.viewer3d.controls.clip_editor.ClipPlaneUI();
        clipPlaneUI3 = new org.visnow.vn.geometries.viewer3d.controls.clip_editor.ClipPlaneUI();
        jPanel1 = new javax.swing.JPanel();

        setLayout(new java.awt.GridBagLayout());

        clipPlaneUI1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        clipPlaneUI1.setName("clipPlaneUI1"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 120;
        gridBagConstraints.ipady = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        add(clipPlaneUI1, gridBagConstraints);

        clipPlaneUI2.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        clipPlaneUI2.setName("clipPlaneUI2"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(clipPlaneUI2, gridBagConstraints);

        clipPlaneUI3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        clipPlaneUI3.setName("clipPlaneUI3"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(clipPlaneUI3, gridBagConstraints);

        jPanel1.setName("jPanel1"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 258, Short.MAX_VALUE)
                );
        jPanel1Layout.setVerticalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 11, Short.MAX_VALUE)
                );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents
     // Variables declaration - do not modify//GEN-BEGIN:variables

    protected org.visnow.vn.geometries.viewer3d.controls.clip_editor.ClipPlaneUI clipPlaneUI1;
    protected org.visnow.vn.geometries.viewer3d.controls.clip_editor.ClipPlaneUI clipPlaneUI2;
    protected org.visnow.vn.geometries.viewer3d.controls.clip_editor.ClipPlaneUI clipPlaneUI3;
    protected javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
}
